<template>
  <div class="px-5">
    <v-row justify="center" class="mt-2 grey lighten-3 pa-12">
      <v-col cols="12" sm="8" class="white">
        <v-card class="card d-flex flex-wrap mx-3" color="primary" dark>
          <v-col class="text-center" cols="12">
            <span class="subtitle-1">
              DEPARTMENT FORM
            </span>
          </v-col>
        </v-card>
        <v-form
          ref="form"
          v-model="valid"
          lazy-validation
        >
          <v-container class="py-0">
            <v-row justify="center">
              <v-col cols="12" md="7">
                <v-text-field
                  :value="departmentname"
                  :rules="departmentrule"
                  :counter="25"
                  label="Department Name"
                  @change="$emit('update:departmentname', $event)"
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" md="7">
                <v-text-field
                  :value="departmentcode"
                  :counter="5"
                  :rules="coderule"
                  label="Department Code"
                  @change="$emit('update:departmentcode', $event)"
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" md="7">
                <v-text-field
                  :value="departmentshortname"
                  :counter="5"
                  :rules="shortrule"
                  label="Department Short Name"
                  @change="$emit('update:departmentshortname', $event)"
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" md="7" class="mt-5 text-center">
                <v-btn
                  :disabled="!valid"
                  :loading="loading"
                  color="secoundary"
                  class="ma-2 white--text"
                  width="100"
                  v-on:click="validate"
                >
                  ADD
                </v-btn>
                <v-btn
                  color="warning"
                  class="ma-2"
                  v-on:click="cancel"
                >
                  Cancel
                </v-btn>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-col>
    </v-row>
  </div>
</template>
<script>

export default {
  data() {
    return {
      valid: true,
      currentDateWithFormat: new Date().toJSON().slice(0, 10).replace(/-/g, '/'),
      shortrule: [
        (v) => !!v || 'Code is required',
        (v) => (v && v.length <= 5) || 'Code must be less than 5 characters',
      ],
      coderule: [
        (v) => !!v || 'Code is required',
        (v) => (v && v.length <= 5) || 'Code must be less than 5 characters',
      ],
      departmentrule: [
        (v) => !!v || 'Name is required',
        (v) => (v && v.length <= 25) || 'Name must be less than 25 characters',
      ],
    };
  },
  props: {
    departmentname: {
      type: String,
      required: true,
    },
    departmentcode: {
      type: String,
      required: true,
    },
    departmentshortname: {
      type: String,
      required: true,
    },
    loading: {
      type: Boolean,
      required: false,
    },
  },
  methods: {
    validate() {
      if (this.$refs.form.validate()) {
        this.$emit('submit');
      }
    },
    cancel() {
      this.$emit('cancel');
    },
  },

};
</script>

<style scoped>
.card {
  top: -20px;
}
</style>
